<template>
    <b-container style="padding: 2%;">
        <b-card title="Estudiantes" class="mb-2">
            <b-container class="bv-example-row" fluid="md">
                <b-row align-h="end">
                    <b-col cols="5" md="4"	lg="4"	xl="4">
                        <b-input-group>
                            <b-form-input
                            id="filter-input"
                            v-model="filter"
                            type="search"
                            placeholder="Buscar"
                            ></b-form-input>
                        </b-input-group>
                    </b-col>
                    <b-col cols="6" md="4"	lg="3"	xl="3">
                        <b-button block href="#" variant="primary" @click="showModalCreate=true" style="padding-bottom: 5px;">Nuevo Estudiante</b-button>
                    </b-col>
                </b-row>
                <b-row>
                    <b-col>
                        <b-card-text>
                            <b-container>
                                <b-row align-v="center">
                                    <b-col align-self="center">
                                        <b-table striped hover :items="items" :fields="fields" :filter="filter">
                                            <template v-slot:cell(actions)="row">
                                                <b-button variant="outline-warning" @click="handleEdit(row)" class="mb-2">
                                                    <b-icon icon="pencil-square" aria-hidden="true"></b-icon>
                                                </b-button>
                                                <b-button variant="outline-danger" @click="handleDelete(row)" class="mb-2">
                                                    <b-icon icon="trash" aria-hidden="true"></b-icon>
                                                </b-button>
                                            </template>
                                        </b-table>
                                    </b-col>
                                </b-row>
                            </b-container>
                        </b-card-text>
                    </b-col>
                </b-row>
            </b-container>
        </b-card>

        <!-- Modal Edit -->
        <b-modal :id="infoModal.id" :title="infoModal.title" @hidden="resetModal" @ok="handleOk">
            <form id="modal-edit" ref="formEdit" @submit.stop.prevent="handleSubmit">
                <b-container>
                    <b-row>
                        <input type="hidden" ref="type_form" value="true">
                        <b-col cols="12" md="6">
                            <b-form-group :state="editnameState" label="Nombre" label-for="editname" invalid-feedback="El nombre es requerido" >
                                <b-form-input hidden class="sr-only" id="editid" v-model="editid" required ></b-form-input>
                                <b-form-input id="editname" v-model="editname" :state="editnameState" required ></b-form-input>
                            </b-form-group>
                        </b-col>
                        <b-col cols="12" md="6">
                            <b-form-group :state="editlastNameState" label="Apellido" label-for="editlastname" invalid-feedback="El apellido es requerido" >
                                <b-form-input id="editlastname" v-model="editlastname" :state="editlastNameState" required ></b-form-input>
                            </b-form-group>
                        </b-col>
                        <b-col cols="12" md="6">
                            <b-form-group :state="editageState" label="Edad" label-for="editage" invalid-feedback="La edad es requerida" >
                                <b-form-input id="editage" v-model="editage" :state="editageState" required ></b-form-input>
                            </b-form-group>
                        </b-col>
                        <b-col cols="12" md="6">
                            <b-form-group :state="editschoolState" label="Escuela" label-for="editschool" invalid-feedback="La escuela es requerida" >
                                <b-form-select id="editschool" v-model="editschoolselected" :options="editoptions" :state="editschoolState" required></b-form-select>
                            </b-form-group>
                        </b-col>
                    </b-row>
                </b-container>
            </form>
        </b-modal>

        <b-modal v-model="showModalCreate" ref="modal" title="Nuevo cliente" size="lg" @show="resetModal" @hidden="resetModal" @ok="handleOk">
            <form ref="form" @submit.stop.prevent="handleSubmit">
                <b-container>
                    <b-row>
                        <input type="hidden" ref="type_form" value="false">
                        <b-col cols="12" md="6">
                            <b-form-group :state="nameState" label="Nombre" label-for="name" invalid-feedback="El nombre es requerido" >
                                <b-form-input id="name" v-model="name" :state="nameState" required ></b-form-input>
                            </b-form-group>
                        </b-col>
                        <b-col cols="12" md="6">
                            <b-form-group :state="lastNameState" label="Apellido" label-for="lastname" invalid-feedback="El apellido es requerido" >
                                <b-form-input id="lastname" v-model="lastname" :state="lastNameState" required ></b-form-input>
                            </b-form-group>
                        </b-col>
                        <b-col cols="12" md="6">
                            <b-form-group :state="ageState" label="Edad" label-for="age" invalid-feedback="La edad es requerida" >
                                <b-form-input id="age" v-model="age" :state="ageState" required ></b-form-input>
                            </b-form-group>
                        </b-col>
                        <b-col cols="12" md="6">
                            <b-form-group :state="schoolState" label="Escuela" label-for="school" invalid-feedback="La escuela es requerida" >
                                <b-form-select id="school" v-model="schoolselected" :options="options" :state="schoolState" required></b-form-select>
                            </b-form-group>
                        </b-col>
                    </b-row>
                </b-container>
            </form>
        </b-modal>
    </b-container>
</template>

<script>
  export default {
    data() {
      return {
        showModalCreate: false,
        filter: null,
        name: '',
        nameState: null,
        lastname: '',
        lastNameState: null,
        age: '',
        ageState: null,
        schoolselected: null,
        schoolState: null,
        options: [
            { value: null, text: 'Seleccione una opcion' },
        ],

        editid: '',
        editname: '',
        editnameState: null,
        editlastname: '',
        editlastNameState: null,
        editage: '',
        editageState: null,
        editschoolselected: null,
        editschoolState: null,
        editoptions: [
            { value: null, text: 'Seleccione una opcion' },
        ],

        fields: [
            { key: 'name', label: 'Nombre' },
            { key: 'lastname', label: 'Apellido' },
            { key: 'age', label: 'Edad' },
            { key: 'school.name', label: 'Escuela' },
            { key: 'actions', label: 'Acciones' },
        ],
        items: [],

        infoModal: {
            id: 'info-modal',
            title: '',
            content: ''
        }
      }
    },
    created() {
        this.axios
            .get('http://students.test/api/students')
            .then(response => {
                this.items = response.data;
            });
        this.axios
            .get('http://students.test/api/schools')
            .then(response => {
                response.data.forEach(element => {
                    this.options.push({ value: element.id, text: element.name});
                    this.editoptions.push({ value: element.id, text: element.name});
                });
            });
    },
    watch: {
        showModalCreate: function (val) {
            this.resetModal()
        },
    },
    methods: {
        checkFormValidity() {
            if (this.$refs.type_form.value == 'true') {
                const valid = this.$refs.formEdit.checkValidity()
                this.editnameState = (this.editname != '')
                this.editlastNameState = (this.editlastname != '')
                this.editageState = (this.editage != '')
                this.editschoolState = (this.editschoolselected != null)
                return valid
            } else {
                const valid = this.$refs.form.checkValidity()
                this.nameState = (this.name != '')
                this.lastNameState = (this.lastname != '')
                this.ageState = (this.age != '')
                this.schoolState = (this.schoolselected != null)
                return valid
            }
        },
        resetModal() {
            this.name = ''
            this.nameState = null
            this.lastname = ''
            this.lastNameState = null
            this.age = ''
            this.ageState = null
            this.schoolselected = null
            this.schoolState = null

            this.editid = ''
            this.editname = ''
            this.editnameState = null
            this.editlastname = ''
            this.editlastNameState = null
            this.editage = ''
            this.editageState = null
            this.editschoolselected = null
            this.editschoolState = null
        },
        handleOk(bvModalEvt) {
            // Prevent modal from closing
            bvModalEvt.preventDefault()
            // Trigger submit handler
            this.handleSubmit()
        },
        handleSubmit() {
            // Exit when the form isn't valid
            if (!this.checkFormValidity()) {
                return
            }
            if (this.$refs.type_form.value == 'true') {
                let editItem = {
                    id: this.editid,
                    name: this.editname,
                    lastname: this.editlastname,
                    age: this.editage,
                    school_id: this.editschoolselected,
                };

                this.axios
                .put('http://students.test/api/students/'+this.editid, editItem)
                .then(response => {
                    this.$set(this.items, this.infoModal.content.index, response.data.student)
                });

                // Hide the modal manually
                this.$nextTick(() => {
                    // this.$bvModal.hide('modal-edit')
                    this.$root.$emit('bv::hide::modal', this.infoModal.id)
                })

            } else {
                let newItem = {
                    name: this.name,
                    lastname: this.lastname,
                    age: this.age,
                    school_id: this.schoolselected,
                };
                this.axios
                .post('http://students.test/api/students', newItem)
                .then(response => {
                    this.items.splice(0,0,response.data.student);
                });

                // Hide the modal manually
                this.$nextTick(() => {
                    this.showModalCreate = false;
                })
            }

        },
        handleEdit(row) {
            this.infoModal.title = `Estudiante: ${row.item.name} ${row.item.lastname}`
            this.infoModal.content = row
            this.editid = row.item.id
            this.editname = row.item.name
            this.editlastname = row.item.lastname
            this.editage = row.item.age
            this.editschoolselected = row.item.school_id
            this.$root.$emit('bv::show::modal', this.infoModal.id)
        },
        handleDelete(row) {
            this.$bvModal.msgBoxConfirm('Desea eliminar este cliente?')
                .then(value => {
                    if (value == true) {
                        this.axios
                            .delete('http://students.test/api/students/'+row.item.id)
                            .then(response => {
                                this.items.splice(row.index, 1);
                            });
                    }
                })
                .catch(err => {
                // An error occurred
                })
        },
    }
  }
</script>

<style>
    .custom-select {
        display: inline-block;
        width: 100%;
        height: calc(1.5em + 0.75rem + 2px);
        padding: 0.375rem 1.75rem 0.375rem 0.75rem;
        font-size: 1rem;
        font-weight: 400;
        line-height: 1.5;
        color: #495057;
        vertical-align: middle;
        background: #fff url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='4' height='5'%3E%3Cpath fill='%23343a40' d='M2 0L0 2h4zm0 5L0 3h4z'/%3E%3C/svg%3E") no-repeat right .75rem center/8px 10px;
        border: 1px solid #ced4da;
        border-radius: 0.25rem;
        -webkit-appearance: none;
        -moz-appearance: none;
        appearance: none;
    }

    .modal-header .close {
        padding: 1rem;
        margin: -1rem -1rem -1rem auto;
    }
    button.close {
        padding: 0;
        background-color: transparent;
        border: 0;
    }
    .close {
        float: right;
        font-size: 1.5rem;
        font-weight: 700;
        line-height: 1;
        color: #000;
        text-shadow: 0 1px 0 #fff;
        opacity: .5;
    }
    .modal-backdrop {
        z-index: 1071;
    }
    .modal-backdrop {
        opacity: .5;
    }
    .modal-backdrop {
        position: fixed;
        top: 0;
        left: 0;
        z-index: 1040;
        width: 100vw;
        height: 100vh;
        background-color: #000;
    }
</style>
